/* cFile.c */
/* Umgang mit formatierten Dateien */
#include <conio.h> //wg. _getch()
#include <stdio.h> //wg. printf()

#pragma warning(disable : 4996) // ("veraltet")

#define LONG  80
#define NAME  "cFile.txt"
#define PATH  "..\\dat\\"
#define PREC  0
#define WIDE  6

int main(void) 
{ FILE *filnam;
  int   ii=1, jj=5;
  char  string[LONG], *dummys=NULL;
  float ff=0.f;

  printf ("Aris Christidis: \nDealing with files in C\n");
  /*Neue Datei oeffnen, auch zum Lesen; Leerzeichen trennt von PATH und NAME:*/
  if ((filnam=fopen(PATH NAME, "w+"))==NULL) return(-1); 

  /*Numerierung, Tabulator, Pipeline-Symbol;
    Dateiname: 12 Stellen reserviert, 10 (von 9) Buchstaben rechtsbuendig; Text:*/
  fprintf(filnam, "0.\t|%12.10s contents\t; comments ignored\n", NAME); 

  /*Numerierung, Tabulator, Pipeline-Symbol;
    negiertes ii, mit 4 (evtl. mit 0 aufgefuellten) Stellen, rechtsbuendig; 
    nachgesetzter Punkt, Komma, Leerzeichen; noch einmal negiertes ii, 
    ohne Auffuellen, mit jj reservierten, aber  mind. 2 Ziffern, linksbuendig;
    Punkt, 2 Tabs, Semikolon, Text:*/
  fprintf(filnam, "1.\t|%04d., %-*.2d.\t\t; integer\n", -ii, jj, -ii);

  /*Numerierung, Tabulator, Pipeline-Symbol;
    negiertes ii als float, mit insg. 7 (darunter 3 Nachkomma-)Stellen, 
    evtl. mit 0 aufgefuellt, Komma, Leerzeichen; noch einmal negiertes float, 
    Vorkomma-Stellen nach Berdarf, ii Nachkomma-Stellen; 2 Tabs, Semikolon, Text:*/
  fprintf(filnam, "2.\t|%07.3f, %.*f\t\t; float\n", (float)-ii, ii, -(float)ii); //beides korrekt

  /*Genauigkeit=0 => keine Ausgabe des Wertes 0:*/
  fprintf(filnam, "3.\t|%d|%*.*d|\t\t; integer\n", PREC, jj, PREC, PREC);

  /*Numerierung, Tabulator, Pipeline-Symbol;
    Anfuerungsstriche, linksbuendig 6 Zeichen ausgeben, 5 davon aus "Diners",
   "for", ii rechtsbuendig mit ii+1 Stellen, ii+1 3stellig mit einer Nachkomma-Stelle;
    Tabulator, Semikolon, Text:*/
  fprintf (filnam,"4.\t|\"%-*.*sfor%*d\" %3.1f\t; text\n", WIDE, WIDE-1, "Diners", 
                                                           ii+1, ii, (float)ii+1);
  fflush(filnam); rewind(filnam);
  fclose (filnam);
/* ------------------------------------------------------------ */
  /*Nur zum Lesen oeffnen:*/
  if ((filnam=fopen(PATH NAME, "r"))==NULL) return(-1); 

  /*0. Alles (ohne Speicherung) uebergehen, was kein Buchstabe ist:*/
  printf ("\n0. ");
  //fscanf(filnam, "%*[^A-Z^a-z]s", string);
  fscanf (filnam,"%*[^A-Z^a-z]s", string);
  /*Herauslesen von Zeichen, die zum Dateinamen gehoeren koennen:*/
  fscanf (filnam,"%[.A-Za-z1-9]s", string);
  printf ("Name: %s;", string);
  /*Rest der Zeile inkl. <CR> "aufbrauchen":*/
  dummys = fgets (string, LONG, filnam); 
  if (dummys != string) { printf ("\nSTOP!\n"); getch(); }

  /*1. Initialisieren:*/
  ii=-15; ff=-15.;
  /*Alles uebergehen bis inkl. Pipeline-Zeichen '|':*/
  fscanf (filnam,"%*[^|]s", string);
  fscanf (filnam,"%*[|]s", string);
  /*String sollte noch unveraendert sein:*/
  printf ("\tstring: %s\n", string);
  printf ("\n1. ");
  /*Lesen von int mit nachgesetztem Punkt als float:*/
  fscanf (filnam, "%f", &ff);
  /*Trennzeichen lesen, bis eine Zahl kommt:*/
  fscanf (filnam,"%[^0-9^+^-]s", string);
  /*int lesen:*/
  fscanf (filnam, "%d", &ii);
  printf ("ff = %5.2f; ii = %d; ", ff, ii);
  /*Rest der Zeile inkl. <CR> lesen:*/
  fgets (string, LONG, filnam); 
  printf ("\tstring: %s\n", string);

  /*2. Initialisieren:*/
  ii=-15; ff=-15.;
  /*Lesen, bis weisse Zeichen kommen:*/
  printf ("\n2. "); 
  fscanf (filnam,"%[^\t^'\40']s", string);
  /*Lesen, was nicht zu int gehoert:*/
  fscanf (filnam,"%[^0-9^+^-]s", string);
  /*Erste Zahl als int lesen:*/
  fscanf (filnam,"%d", &ii);
  printf ("ii = %d; ", ii);
  /*Weiterlesen, bis weisse Zeichen kommen:*/
  fscanf (filnam,"%[^\t^'\40']s", string); 
  /*Zweite Zahl als float lesen:*/
  fscanf (filnam,"%f", &ff);
  printf ("ff = %5.2f", ff);
  /*Rest der Zeile inkl. <CR> lesen:*/
  dummys = fgets (string, LONG, filnam); 
  printf ("\tstring: %s\n", string);

  /*3. Zeilen als Ganzes lesen:*/
  printf ("\n3. ");
  fgets (string, LONG, filnam); 
  printf ("string: %s\n", string);

  /*4. Alles uebergehen bis Anfuehrungszeichen:*/
  printf ("\n4. ");
  fscanf (filnam,"%*[^\"]s", string);
  /*Lesen bis Semikolon:*/
  fscanf (filnam,"%[^;]s", string);
  printf ("%s", string);
  /*Rest der Zeile inkl. <CR> lesen:*/
  fgets (string, LONG, filnam); 
  printf ("string: %s", string);

  fclose (filnam);
/* ------------------------------------------------------------ */
  _getch(); 
  return (0);
}
